// ///////////////////////////////////////////////////////////////
// No warranty is expressed or implied.
// MyMoney, MyMoney Jr. (etc.) are registered trademarks of MTH,Inc.
// All other company and product names are trademarks are the property of their
// respective holders.
// Copyright 2006 by MTH,Inc. Printed in USA. All rights reserved.
//
// ////////////////////////////////////////////////////////////////
// FILE :
//
// DESCRIPTION :
//
// OWNER : Tim
//
// ====================================================================
//
// $Header: /cvsroot/MyMoney/src/com/mth/mymoney/components/screenlocker/matrix/MatrixCode.java,v 1.1 2007/11/27 06:40:10 tim Exp $
// $Revision: 1.1 $
// $Date: 2007/11/27 06:40:10 $



package com.mth.mymoney.components.screenlocker.matrix;


import java.awt.Graphics2D;


/**
 * 
 * @author Tim
 * 
 */
public class MatrixCode {

    private final static int        WAITING_STATE = 0;
    private final static int        DRAWING_STATE = 1;
    private final static int        FADING_STATE  = 2;

    private static java.util.Random rNumGen       = new java.util.Random();

    MatrixCharacter                 _charPainter;
    int                             _numOfCharacters;
    int                             _numOfRows;

    int                             _column;
    int                             _currentRow;
    int                             _tailRow;
    int                             _firstChar;
    int                             _state;
    int                             _waitCount;
    int                             _speed;
    int                             _skipCount;


    /** Creates a new instance of MatrixCode */
    public MatrixCode(int column,
                      MatrixScreenLocker simulator)
    {

        _column = column;
        _charPainter = simulator.getCharacterPainter();
        _numOfRows = simulator.getNumOfRows();
        _numOfCharacters = _charPainter.getNumOfCharacters();
        _currentRow = 0;
        _tailRow = 0;
        _firstChar = rNumGen.nextInt( _numOfCharacters );
        _state = WAITING_STATE;
        _waitCount = rNumGen.nextInt( 50 );
        _speed = rNumGen.nextInt( 5 );
        _skipCount = 0;
    }

    // this paints the line and increments the state of the line
    public void paint( Graphics2D g2 ) {

        if ( _skipCount < _speed ) {
            _skipCount++;
            return;
        }
        else {
            _skipCount = 0;
        }

        switch ( _state ) {
            case FADING_STATE:
                _charPainter.eraseCharacter( g2,
                                             _column,
                                             _tailRow++ );
                if ( _tailRow > _numOfRows ) {
                    _currentRow = 0;
                    _state = WAITING_STATE;
                    _waitCount = rNumGen.nextInt( 10 );
                }
            break;
            case DRAWING_STATE:
                // repaint head in dim color
                if ( _currentRow > 0 ) {
                    _charPainter.paintCharacter( _firstChar,
                                                 g2,
                                                 _column,
                                                 _currentRow - 1,
                                                 false );
                    _firstChar = rNumGen.nextInt( _numOfCharacters );
                    _charPainter.paintCharacter( _firstChar,
                                                 g2,
                                                 _column,
                                                 _currentRow++,
                                                 true );
                }
                else {
                    _charPainter.paintCharacter( _firstChar,
                                                 g2,
                                                 _column,
                                                 _currentRow++,
                                                 true );
                }

                if ( _currentRow > _numOfRows + 1 ) {
                    _tailRow = 0;
                    _state = FADING_STATE;
                }
            break;
            case WAITING_STATE:
                _waitCount--;
                if ( _waitCount <= 0 ) {
                    _state = DRAWING_STATE;
                    _speed = rNumGen.nextInt( 5 );
                }
            break;
        }
    }

}
