--==============================================================
-- DBMS name:      IBM DB2 UDB 8.x Common Server
-- Created on:     12/4/2007 7:01:38 PM
--==============================================================


alter table MTHADMIN.MMY_ACCOUNT
   drop foreign key F_MMY_ACCNT_HELDAT;

alter table MTHADMIN.MMY_DOUBLEENTRY
   drop foreign key F_MMY_DE_LEFTACCNT;

alter table MTHADMIN.MMY_DOUBLEENTRY
   drop foreign key F_MMY_DE_LEFTTRAN;

alter table MTHADMIN.MMY_FI
   drop foreign key F_MMY_FI_ADDRESS;

alter table MTHADMIN.MMY_MEMORIZEDTRANSACTION
   drop foreign key F_MMY_MEM_TRAN;

alter table MTHADMIN.MMY_PAYEE
   drop foreign key F_MMY_PAYEE_ADDRES;

alter table MTHADMIN.MMY_SPLIT
   drop foreign key F_MMY_SPLIT_CATEGO;

alter table MTHADMIN.MMY_SPLIT
   drop foreign key F_MMY_SPLIT_INSTR;

alter table MTHADMIN.MMY_SPLIT
   drop foreign key F_MMY_SPLIT_PAYEE;

alter table MTHADMIN.MMY_SPLIT
   drop foreign key F_MMY_SPLIT_SUBCAT;

alter table MTHADMIN.MMY_SPLIT
   drop foreign key F_MMY_SPLIT_TRAN;

drop index MTHADMIN.MMY_ACCNTNAME;

drop index MTHADMIN.MMY_CATNAME;

drop index MTHADMIN.MMY_PARENTID;

drop index MTHADMIN.MMY_FINAME;

drop index MTHADMIN.MMY_PAYEENAME;

alter table MTHADMIN.MMY_ACCOUNT
   drop primary key;

alter table MTHADMIN.MMY_ADDRESS
   drop primary key;

alter table MTHADMIN.MMY_CATEGORY
   drop primary key;

alter table MTHADMIN.MMY_DBVERSION
   drop primary key;

alter table MTHADMIN.MMY_DOUBLEENTRY
   drop primary key;

alter table MTHADMIN.MMY_FI
   drop primary key;

alter table MTHADMIN.MMY_INSTRUMENT
   drop primary key;

alter table MTHADMIN.MMY_MEMORIZEDTRANSACTION
   drop primary key;

alter table MTHADMIN.MMY_PAYEE
   drop primary key;

alter table MTHADMIN.MMY_SPLIT
   drop primary key;

alter table MTHADMIN.MMY_TRANSACTION
   drop primary key;

drop table MTHADMIN.MMY_ACCOUNT;

drop table MTHADMIN.MMY_ADDRESS;

drop table MTHADMIN.MMY_CATEGORY;

drop table MTHADMIN.MMY_DBVERSION;

drop table MTHADMIN.MMY_DOUBLEENTRY;

drop table MTHADMIN.MMY_FI;

drop table MTHADMIN.MMY_INSTRUMENT;

drop table MTHADMIN.MMY_MEMORIZEDTRANSACTION;

drop table MTHADMIN.MMY_PAYEE;

drop table MTHADMIN.MMY_SPLIT;

drop table MTHADMIN.MMY_TRANSACTION;

--==============================================================
-- User: MTHADMIN
--==============================================================
--==============================================================
-- Table: MMY_ACCOUNT
--==============================================================
create table MTHADMIN.MMY_ACCOUNT
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   ANAME                VARCHAR(100),
   COMMENTS             VARCHAR(1024),
   ANUM                 VARCHAR(60),
   ACODE                VARCHAR(60),
   ABREV                VARCHAR(20),
   MINBAL               DOUBLE,
   MAXBAL               DOUBLE,
   OPENBAL              DOUBLE,
   RECONCILEDBAL        DOUBLE,
   RECONCILEDDATE       DATE,
   RATE                 DOUBLE,
   ALOCAL               VARCHAR(10),
   CLOSED               CHAR(1),
   FAVORITE             CHAR(1),
   ONLINE               CHAR(1),
   HELDATID             BIGINT,
   ACATEGORY            SMALLINT,
   ATYPE                SMALLINT,
   SYNONYMS             VARCHAR(256),
   OFXBANKID            VARCHAR(40),
   OFXBRANCHID          VARCHAR(40),
   OFXAKEY              VARCHAR(20),
   OFXBALANCEDATE       TIMESTAMP,
   OFXBALANCE           DOUBLE,
   OFXAVAILABLEBALANCE  DOUBLE,
   OFXDOWNLOADENDDATE   TIMESTAMP,
   OFXDOWNLOADSTARTDATE TIMESTAMP,
   OFXDOWNLOADDATE      TIMESTAMP,
   OFXAVAILABLEBALANCEDATE TIMESTAMP
);

alter table MTHADMIN.MMY_ACCOUNT
   add constraint P_MMY_ACCOUNT primary key (ID);

--==============================================================
-- Index: MMY_ACCNTNAME
--==============================================================
create index MTHADMIN.MMY_ACCNTNAME on MTHADMIN.MMY_ACCOUNT (
   ANAME                ASC
)
cluster;

--==============================================================
-- Table: MMY_ADDRESS
--==============================================================
create table MTHADMIN.MMY_ADDRESS
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   ADDRESS              VARCHAR(120),
   CITY                 VARCHAR(40),
   STATE                VARCHAR(30),
   POSTALCODE           VARCHAR(20),
   PHONE                VARCHAR(26),
   FAX                  VARCHAR(26),
   EMAIL                VARCHAR(80)
);

alter table MTHADMIN.MMY_ADDRESS
   add constraint P_MMY_ADDRESS primary key (ID);

--==============================================================
-- Table: MMY_CATEGORY
--==============================================================
create table MTHADMIN.MMY_CATEGORY
(
   ID                   BIGINT                 not null generated by default as identity
      (
          start with 1000,
          increment by 1
      ),
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   CATNAME              VARCHAR(100),
   INDENT               SMALLINT,
   TRANCAT              SMALLINT,
   PARENTID             SMALLINT,
   TAXP                 CHAR(1),
   TAXB                 CHAR(1),
   TAXVAT               CHAR(1),
   SYNONYMS             VARCHAR(256),
   FAVORITE             CHAR(1)
);

alter table MTHADMIN.MMY_CATEGORY
   add constraint P_MMY_CATEGORY primary key (ID);

--==============================================================
-- Index: MMY_CATNAME
--==============================================================
create index MTHADMIN.MMY_CATNAME on MTHADMIN.MMY_CATEGORY (
   CATNAME              ASC
);

--==============================================================
-- Index: MMY_PARENTID
--==============================================================
create index MTHADMIN.MMY_PARENTID on MTHADMIN.MMY_CATEGORY (
   PARENTID             ASC
);

--==============================================================
-- Table: MMY_DBVERSION
--==============================================================
create table MTHADMIN.MMY_DBVERSION
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   MAJOR                INTEGER,
   MINOR                INTEGER,
   BUILD                INTEGER
);

alter table MTHADMIN.MMY_DBVERSION
   add constraint P_MMY_DBVERSION primary key (ID);

--==============================================================
-- Table: MMY_DOUBLEENTRY
--==============================================================
create table MTHADMIN.MMY_DOUBLEENTRY
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   LEFTTRANID           BIGINT                 not null,
   LEFTACCNTID          BIGINT                 not null,
   RIGHTTRANID          BIGINT,
   RIGHTACCNTID         BIGINT
);

alter table MTHADMIN.MMY_DOUBLEENTRY
   add constraint P_MMY_DE primary key (ID);

--==============================================================
-- Table: MMY_FI
--==============================================================
create table MTHADMIN.MMY_FI
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   FINAME               VARCHAR(100),
   SYNONYMS             VARCHAR(256),
   FICATEGORY           SMALLINT,
   FAVORITE             CHAR(1),
   TAXP                 CHAR(1),
   TAXB                 CHAR(1),
   TAXVAT               CHAR(1),
   ADDRESSID            BIGINT,
   OTYPE                SMALLINT,
   WCRYPTED             CHAR,
   WENABLED             CHAR,
   MSGUID               VARCHAR(100)
);

alter table MTHADMIN.MMY_FI
   add constraint P_MMY_FI primary key (ID);

--==============================================================
-- Index: MMY_FINAME
--==============================================================
create index MTHADMIN.MMY_FINAME on MTHADMIN.MMY_FI (
   FINAME               ASC
);

--==============================================================
-- Table: MMY_INSTRUMENT
--==============================================================
create table MTHADMIN.MMY_INSTRUMENT
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   ITYPE                SMALLINT,
   CODE                 VARCHAR(18)
);

alter table MTHADMIN.MMY_INSTRUMENT
   add constraint P_MMY_INSTR primary key (ID);

--==============================================================
-- Table: MMY_MEMORIZEDTRANSACTION
--==============================================================
create table MTHADMIN.MMY_MEMORIZEDTRANSACTION
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   MEMNAME              VARCHAR(40),
   TRANID               BIGINT
);

alter table MTHADMIN.MMY_MEMORIZEDTRANSACTION
   add constraint P_MMY_MEMTRAN primary key (ID);

--==============================================================
-- Table: MMY_PAYEE
--==============================================================
create table MTHADMIN.MMY_PAYEE
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   PNAME                VARCHAR(100),
   SYNONYMS             VARCHAR(256),
   PCATEGORY            SMALLINT,
   ADDRESSID            BIGINT,
   FAVORITE             CHAR(1)
);

alter table MTHADMIN.MMY_PAYEE
   add constraint P_MMY_PAYEE primary key (ID);

--==============================================================
-- Index: MMY_PAYEENAME
--==============================================================
create index MTHADMIN.MMY_PAYEENAME on MTHADMIN.MMY_PAYEE (
   PNAME                ASC
)
cluster;

--==============================================================
-- Table: MMY_SPLIT
--==============================================================
create table MTHADMIN.MMY_SPLIT
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   CHECKNUM             VARCHAR(40),
   AMOUNT               DOUBLE,
   CATEGORYID           BIGINT,
   SUBCATEGORYID        BIGINT,
   MEMO                 VARCHAR(1024),
   TTYPE                SMALLINT,
   PAYEEID              BIGINT,
   INSTRUMENTID         BIGINT,
   TRANID               BIGINT
);

alter table MTHADMIN.MMY_SPLIT
   add constraint P_MMY_SPLIT primary key (ID);

--==============================================================
-- Table: MMY_TRANSACTION
--==============================================================
create table MTHADMIN.MMY_TRANSACTION
(
   ID                   BIGINT                 not null generated by default as identity,
   CDATE                TIMESTAMP,
   MDATE                TIMESTAMP,
   TDATE                DATE,
   TSTATE               SMALLINT,
   RECURRING            CHAR(1),
   REIMBURSABLE         CHAR(1),
   OFXFITID             VARCHAR(40),
   OFXSIC               VARCHAR(40),
   OFXPOSTED            DATE,
   OFXCORRECT           SMALLINT,
   OFXCORRECTID         VARCHAR(40)
);

alter table MTHADMIN.MMY_TRANSACTION
   add constraint P_MMY_TRANSACTIONS primary key (ID);

alter table MTHADMIN.MMY_ACCOUNT
   add constraint F_MMY_ACCNT_HELDAT foreign key (HELDATID)
      references MTHADMIN.MMY_FI (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_DOUBLEENTRY
   add constraint F_MMY_DE_LEFTACCNT foreign key (LEFTACCNTID)
      references MTHADMIN.MMY_ACCOUNT (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_DOUBLEENTRY
   add constraint F_MMY_DE_LEFTTRAN foreign key (LEFTTRANID)
      references MTHADMIN.MMY_TRANSACTION (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_FI
   add constraint F_MMY_FI_ADDRESS foreign key (ADDRESSID)
      references MTHADMIN.MMY_ADDRESS (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_MEMORIZEDTRANSACTION
   add constraint F_MMY_MEM_TRAN foreign key (TRANID)
      references MTHADMIN.MMY_TRANSACTION (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_PAYEE
   add constraint F_MMY_PAYEE_ADDRES foreign key (ADDRESSID)
      references MTHADMIN.MMY_ADDRESS (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_SPLIT
   add constraint F_MMY_SPLIT_CATEGO foreign key (CATEGORYID)
      references MTHADMIN.MMY_CATEGORY (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_SPLIT
   add constraint F_MMY_SPLIT_INSTR foreign key (INSTRUMENTID)
      references MTHADMIN.MMY_INSTRUMENT (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_SPLIT
   add constraint F_MMY_SPLIT_PAYEE foreign key (PAYEEID)
      references MTHADMIN.MMY_PAYEE (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_SPLIT
   add constraint F_MMY_SPLIT_SUBCAT foreign key (SUBCATEGORYID)
      references MTHADMIN.MMY_CATEGORY (ID)
      on delete no action on update no action;

alter table MTHADMIN.MMY_SPLIT
   add constraint F_MMY_SPLIT_TRAN foreign key (TRANID)
      references MTHADMIN.MMY_TRANSACTION (ID)
      on delete no action on update no action;

